//+------------------------------------------------------------------+
//|                                       STRONG_WEAK_CURRENCIES.mq4 |
//|                                                 Copyright  2012 |
//|                                                           Tomcat |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012,Tomcat."
#property link      "Tomcat"

#property indicator_separate_window
//#include <WinUser32.mqh>
//#include <stdlib.mqh>
#property indicator_buffers 8
#property indicator_level1  0

#property indicator_color1 Green
#property indicator_color2 Blue
#property indicator_color3 Aqua
#property indicator_color4 Ivory
#property indicator_color5 Yellow
#property indicator_color6 Red
#property indicator_color7 Maroon
#property indicator_color8 DarkGray

color indicator_clr1 = Green;         //USD
color indicator_clr2 = Blue;          //EUR 
color indicator_clr3 = Aqua;          //GBP
color indicator_clr4 = Ivory;         //CHF
color indicator_clr5 = Yellow;        //AUD
color indicator_clr6 = Red;           //CAD
color indicator_clr7 = Maroon;        //JPY
color indicator_clr8 = DarkGray;      //NZD
//---- indicator parameters
extern int TimeFrame  =0;
bool       recalculate ;
bool       Init       =true;
bool       exit       = false;
//---- indicator buffers
double     USD_Buffer[];
double     EUR_Buffer[];
double     GBP_Buffer[];
double     CHF_Buffer[];
double     AUD_Buffer[];
double     CAD_Buffer[];
double     JPY_Buffer[];
double     NZD_Buffer[];

double     BASKET_BUFFER[];

string short_name;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- name for DataWindow and indicator subwindow label 
    IndicatorBuffers(8);
    SetIndexBuffer(0,USD_Buffer);   
    SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1,indicator_color1);
    SetIndexLabel(0,"USD");
    SetIndexDrawBegin(0,TimeFrame);
    SetIndexBuffer(1,EUR_Buffer);
    SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,indicator_color2);
    SetIndexLabel(1,"EUR");
    SetIndexDrawBegin(1,TimeFrame);   
    SetIndexBuffer(2,GBP_Buffer);
    SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1,indicator_color3);
    SetIndexLabel(2,"GBP");
    SetIndexDrawBegin(2,TimeFrame);    
    SetIndexBuffer(3,CHF_Buffer);
    SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1,indicator_color4); 
    SetIndexLabel(3,"CHF");
    SetIndexDrawBegin(3,TimeFrame);     
    SetIndexBuffer(4,AUD_Buffer);
    SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1,indicator_color5); 
    SetIndexLabel(4,"AUD");
    SetIndexDrawBegin(4,TimeFrame);   
    SetIndexBuffer(5,CAD_Buffer);
    SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,1,indicator_color6); 
    SetIndexLabel(5,"CAD");
    SetIndexDrawBegin(5,TimeFrame);    
    SetIndexBuffer(6,JPY_Buffer);
    SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,1,indicator_color7); 
    SetIndexLabel(6,"JPY");
    SetIndexDrawBegin(6,TimeFrame);   
    SetIndexBuffer(7,NZD_Buffer);
    SetIndexStyle(7,DRAW_LINE,STYLE_SOLID,1,indicator_color8); 
    SetIndexLabel(7,"NZD");
    SetIndexDrawBegin(7,TimeFrame);    
    short_name="STRONG_WEAK_CURRENCIES("+TimeFrame+")";
    IndicatorShortName(short_name);
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  Comment("");
  return (0);  
  }
  
//+------------------------------------------------------------------+
//| STRONG_WEAK_CURRENCIES                                           |
//+------------------------------------------------------------------+
int start()
  {
   if(exit)
       return(0);
 //---- amount not changed bars after last call of the indicator --+      
  int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   if(recalculate)
     {
      int limit = Bars;
      recalculate = false;
     }
   else limit = Bars - counted_bars;
   //---- set values of candles -------------------------------------+
   for(int i=limit; i>=0; i--)
     {
       datetime time_bar = Time[i];   
       //int bar_no = iBarShift(symbol, Period(), time_bar, false);
     
   //---- set values of candles -------------------------------------+  
   int bar_no_EURUSD = iBarShift("EURUSD", Period(), time_bar, false); 
   double close_EURUSD=iClose("EURUSD",Period(),bar_no_EURUSD);
   
   int bar_no_GBPUSD = iBarShift("GBPUSD", Period(), time_bar, false);
   double close_GBPUSD=iClose("GBPUSD",Period(),bar_no_GBPUSD);
   
   int bar_no_USDCHF = iBarShift("USDCHF", Period(), time_bar, false);   
   double close_USDCHF=iClose("USDCHF",Period(),bar_no_USDCHF);
   
   int bar_no_AUDUSD = iBarShift("AUDUSD", Period(), time_bar, false);
   double close_AUDUSD=iClose("AUDUSD",Period(),bar_no_AUDUSD);
   
   int bar_no_USDCAD = iBarShift("USDCAD", Period(), time_bar, false);
   double close_USDCAD=iClose("USDCAD",Period(),bar_no_USDCAD);
   
   int bar_no_USDJPY = iBarShift("USDJPY", Period(), time_bar, false);
   double close_USDJPY=iClose("USDJPY",Period(),bar_no_USDJPY);
   
   int bar_no_NZDUSD = iBarShift("NZDUSD", Period(), time_bar, false);
   double close_NZDUSD=iClose("NZDUSD",Period(),bar_no_NZDUSD);
   
   int bar_no_EURGBP = iBarShift("EURGBP", Period(), time_bar, false);
   double close_EURGBP=iClose("EURGBP",Period(),bar_no_EURGBP);
   
   int bar_no_EURCHF = iBarShift("EURCHF", Period(), time_bar, false);
   double close_EURCHF=iClose("EURCHF",Period(),bar_no_EURCHF);
   
   int bar_no_EURAUD = iBarShift("EURAUD", Period(), time_bar, false);
   double close_EURAUD=iClose("EURAUD",Period(),bar_no_EURAUD);
   
   int bar_no_EURCAD = iBarShift("EURCAD", Period(), time_bar, false);
   double close_EURCAD=iClose("EURCAD",Period(),bar_no_EURCAD);
   
   int bar_no_EURJPY = iBarShift("EURJPY", Period(), time_bar, false);
   double close_EURJPY=iClose("EURJPY",Period(),bar_no_EURJPY);
   
   int bar_no_EURNZD = iBarShift("EURUSD", Period(), time_bar, false);
   double close_EURNZD=iClose("EURNZD",Period(),bar_no_EURNZD);
   
   int bar_no_GBPCHF = iBarShift("GBPCHF", Period(), time_bar, false);
   double close_GBPCHF=iClose("GBPCHF",Period(),bar_no_GBPCHF);
   
   int bar_no_GBPAUD = iBarShift("GBPAUD", Period(), time_bar, false);
   double close_GBPAUD=iClose("GBPAUD",Period(),bar_no_GBPAUD);
   
   int bar_no_GBPCAD = iBarShift("GBPCAD", Period(), time_bar, false);
   double close_GBPCAD=iClose("GBPCAD",Period(),bar_no_GBPCAD);
   
   int bar_no_GBPJPY = iBarShift("GBPJPY", Period(), time_bar, false);
   double close_GBPJPY=iClose("GBPJPY",Period(),bar_no_GBPJPY);
   
   int bar_no_GBPNZD = iBarShift("GBPNZD", Period(), time_bar, false);
   double close_GBPNZD=iClose("GBPNZD",Period(),bar_no_GBPNZD);
   
   int bar_no_AUDCHF = iBarShift("AUDCHF", Period(), time_bar, false);
   double close_AUDCHF=iClose("AUDCHF",Period(),bar_no_AUDCHF);
   
   int bar_no_CADCHF = iBarShift("CADCHF", Period(), time_bar, false);
   double close_CADCHF=iClose("CADCHF",Period(),bar_no_CADCHF);
   
   int bar_no_CHFJPY = iBarShift("CHFJPY", Period(), time_bar, false);
   double close_CHFJPY=iClose("CHFJPY",Period(),bar_no_CHFJPY);
   
   int bar_no_NZDCHF = iBarShift("NZDCHF", Period(), time_bar, false);
   double close_NZDCHF=iClose("NZDCHF",Period(),bar_no_NZDCHF);
   
   int bar_no_AUDCAD = iBarShift("AUDCAD", Period(), time_bar, false);
   double close_AUDCAD=iClose("AUDCAD",Period(),bar_no_AUDCAD);
   
   int bar_no_AUDJPY = iBarShift("AUDJPY", Period(), time_bar, false);
   double close_AUDJPY=iClose("AUDJPY",Period(),bar_no_AUDJPY);
   
   int bar_no_AUDNZD = iBarShift("AUDNZD", Period(), time_bar, false);
   double close_AUDNZD=iClose("AUDNZD",Period(),bar_no_AUDNZD);
   
   int bar_no_CADJPY = iBarShift("CADJPY", Period(), time_bar, false);
   double close_CADJPY=iClose("CADJPY",Period(),bar_no_CADJPY);
   
   int bar_no_NZDCAD = iBarShift("NZDCAD", Period(), time_bar, false);
   double close_NZDCAD=iClose("NZDCAD",Period(),bar_no_NZDCAD);
   
   int bar_no_NZDJPY = iBarShift("NZDJPY", Period(), time_bar, false);
   double close_NZDJPY=iClose("NZDJPY",Period(),bar_no_NZDJPY);
   //---
   double BASKET_BUFFER=(close_EURUSD+close_GBPUSD+close_USDCHF+close_AUDUSD+close_USDCAD+close_USDJPY+close_NZDUSD+
                         close_EURGBP+close_EURCHF+close_EURAUD+close_EURCAD+close_EURJPY+close_EURNZD+close_GBPCHF+
                         close_GBPAUD+close_GBPCAD+close_GBPJPY+close_GBPNZD+close_AUDCHF+close_CADCHF+close_CHFJPY+
                         close_NZDCHF+close_AUDCAD+close_AUDJPY+close_AUDNZD+close_CADJPY+close_NZDCAD+close_NZDJPY)/28.0 ;
   //---
      if (BASKET_BUFFER!=0)
      {
         USD_Buffer[i]=(((close_EURUSD+close_GBPUSD+close_USDCHF+close_AUDUSD+close_USDCAD+close_USDJPY+close_NZDUSD)/7.0)/BASKET_BUFFER)+0.012;   
         EUR_Buffer[i]=(((close_EURUSD+close_EURGBP+close_EURCHF+close_EURAUD+close_EURCAD+close_EURJPY+close_EURNZD)/7.0)/BASKET_BUFFER)-0.12;
         GBP_Buffer[i]=(((close_GBPUSD+close_EURGBP+close_GBPCHF+close_GBPAUD+close_GBPCAD+close_GBPJPY+close_GBPNZD)/7.0)/BASKET_BUFFER)-0.275;   
         CHF_Buffer[i]=(((close_USDCHF+close_EURCHF+close_GBPCHF+close_AUDCHF+close_CADCHF+close_CHFJPY+close_NZDCHF)/7.0)/BASKET_BUFFER);
         AUD_Buffer[i]=(((close_AUDUSD+close_EURAUD+close_GBPAUD+close_AUDCHF+close_AUDCAD+close_AUDJPY+close_AUDNZD)/7.0)/BASKET_BUFFER);
         CAD_Buffer[i]=(((close_USDCAD+close_EURCAD+close_GBPCAD+close_CADCHF+close_AUDCAD+close_CADJPY+close_NZDCAD)/7.0)/BASKET_BUFFER)+0.015;
         JPY_Buffer[i]=((((close_USDJPY+close_EURJPY+close_GBPJPY+close_CHFJPY+close_AUDJPY+close_CADJPY+close_NZDJPY)/7.0)/BASKET_BUFFER))-3.282;
         NZD_Buffer[i]=(((close_NZDUSD+close_EURNZD+close_GBPNZD+close_NZDCHF+close_AUDNZD+close_NZDCAD+close_NZDJPY)/7.0)/BASKET_BUFFER)+0.0999;  
      }
   }
   //+------------------------------------------------------------------+
   //| Write  Curr. & code color   text                                 |
   //+------------------------------------------------------------------+    
    
 #define write_position 220
        
        ObjectCreate("USD", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("USD","USD",12, "Arial Bold");
        ObjectSet("USD", OBJPROP_COLOR, Green);
        ObjectSet("USD", OBJPROP_CORNER, 0);
        ObjectSet("USD", OBJPROP_XDISTANCE, write_position+190);
        ObjectSet("USD", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("EUR", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("EUR","EUR",12, "Arial Bold");
        ObjectSet("EUR", OBJPROP_COLOR, Blue );
        ObjectSet("EUR", OBJPROP_CORNER, 0);
        ObjectSet("EUR", OBJPROP_XDISTANCE, write_position+250);//40
        ObjectSet("EUR", OBJPROP_YDISTANCE, 3);

        ObjectCreate("GBP", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("GBP","GBP",12, "Arial Bold");
        ObjectSet("GBP", OBJPROP_COLOR, Aqua );
        ObjectSet("GBP", OBJPROP_CORNER, 0);
        ObjectSet("GBP", OBJPROP_XDISTANCE, write_position+310);//80
        ObjectSet("GBP", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("CHF", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("CHF","CHF",12, "Arial Bold");
        ObjectSet("CHF", OBJPROP_COLOR, Ivory);
        ObjectSet("CHF", OBJPROP_CORNER, 0);
        ObjectSet("CHF", OBJPROP_XDISTANCE, write_position+360);//120
        ObjectSet("CHF", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("AUD", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("AUD","AUD",12, "Arial Bold");
        ObjectSet("AUD", OBJPROP_COLOR, Yellow);
        ObjectSet("AUD", OBJPROP_CORNER, 0);
        ObjectSet("AUD", OBJPROP_XDISTANCE, write_position+410);//160
        ObjectSet("AUD", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("CAD", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("CAD","CAD",12, "Arial Bold");
        ObjectSet("CAD", OBJPROP_COLOR, Red);
        ObjectSet("CAD", OBJPROP_CORNER, 0);
        ObjectSet("CAD", OBJPROP_XDISTANCE, write_position+460);//200
        ObjectSet("CAD", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("JPY", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("JPY","JPY",12, "Arial Bold");
        ObjectSet("JPY", OBJPROP_COLOR, Maroon );
        ObjectSet("JPY", OBJPROP_CORNER, 0);
        ObjectSet("JPY", OBJPROP_XDISTANCE, write_position+510);//240
        ObjectSet("JPY", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("NZD", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("NZD","NZD",12, "Arial Bold");
        ObjectSet("NZD", OBJPROP_COLOR, DarkGray);
        ObjectSet("NZD", OBJPROP_CORNER, 0);
        ObjectSet("NZD", OBJPROP_XDISTANCE, write_position+560);//280
        ObjectSet("NZD", OBJPROP_YDISTANCE, 3);
    return(0); 
  }
//+------------------------------------------------------------------+